#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fun>
#include <hamsandwich>

new CurrentRound
new bool:HasC4[33]

#define PLUGIN "Simple VIP"
#define VERSION "1.1"
#define AUTHOR "ArtHa"

#define VIP ADMIN_LEVEL_H // VIP flag, keisti cia.

new bool:gShopVipmenu = true;

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_logevent("LogEvent_RoundStart", 2, "1=Round_Start" );
	register_event("TextMsg", "round_restart", "a", "2=#Game_will_restart_in");
	RegisterHam( Ham_Spawn, "player", "FnHamSpawn", 1 );
	
	new configsdir[64], file[132]
	get_configsdir(configsdir, 63)
	
	format(file, 131, "%s/blockedmaps.ini", configsdir)	
	load_maps(file)
	
	register_cvar("vipmenu_round","2")
}

public load_maps(path[])
{
	new szMapname[64], szMap[64];
	new file = fopen(path, "rt")

	if(!file)
	{
		server_print("Nepavyko rasti blockedmaps.ini failo!")
		return PLUGIN_HANDLED
	}

	while(!feof(file))
	{
		fgets(file, szMapname, 63)
		if(equal(szMapname[0], "") || equal(szMapname[0], ";"))
		{
			continue;
		}
		get_mapname(szMap, 63)
		if(equali(szMap, szMapname))
		{
			gShopVipmenu = false;
		}
	}
	fclose(file);
	return PLUGIN_CONTINUE
}

public LogEvent_RoundStart()
{
	CurrentRound++;
}

public round_restart()
{
	CurrentRound = 0;
}

public FnHamSpawn(id)
{
	if(gShopVipmenu)
	{
		if(CurrentRound >= get_cvar_num( "vipmenu_round" ) )
		{
			if(get_user_flags(id) & VIP )
			{
				vipmenu(id);
			}
		}
	}
}

public vipmenu(id) 
{
	new menu = menu_create("\w[\y VIP MENU \w]", "menu_handler");
	menu_additem(menu, "\wM4A1 + Deagle", "1", 0);
	menu_additem(menu, "\wAK47 + Deagle", "2", 0);
	menu_additem(menu, "\wFAMAS + Deagle", "3", 0);
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
	menu_display(id, menu, 0); 
}

public menu_handler(id, menu, item)
{
	if( item == MENU_EXIT )
	{
		give_items(id);
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	
	new data[6], iName[64];
	new acess, callback;
   
	menu_item_getinfo(menu, item, acess, data,6, iName, 63, callback);
	new key = str_to_num(data);
	
	switch(key)
	{	
		case 1:
		{
			give_weapons(id, CSW_M4A1, 90, CSW_DEAGLE, 35)
		}
		case 2:
		{         
			give_weapons(id, CSW_AK47, 90, CSW_DEAGLE, 35)
		}
		case 3: 
		{ 
			give_weapons(id, CSW_FAMAS, 90, CSW_DEAGLE, 35)
		}
	}
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public give_weapons(id, prim, ammo1, sec, ammo2)
{
	if(user_has_weapon(id, CSW_C4) )
		HasC4[id] = true;
	else
		HasC4[id] = false;
		
	new weapon[32]
	strip_user_weapons (id)
	get_weaponname(prim, weapon, 31)
	give_item(id,weapon)
	cs_set_user_bpammo(id, prim, ammo1)
 
	get_weaponname(sec, weapon, 31)
	give_item(id,weapon)
	cs_set_user_bpammo(id, sec, ammo2)
 
	give_item(id,"weapon_knife")
    
	if (HasC4[id])
	{
		give_item(id, "weapon_c4")
		cs_set_user_plant( id )
	}
	
	give_items(id)
}