#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <fakemeta_util>
#include <fun>
#include <hamsandwich>

new CurrentRespawn[33]
new bool:HasC4[33]

#define PLUGIN "Simple VIP"
#define VERSION "3.5"
#define AUTHOR "ArtHa"

#define VIP ADMIN_LEVEL_H // VIP flag, keisti cia.
#define ADMIN ADMIN_BAN // ADMIN flag, keisti cia.
#define REMOVE_MENU 20.0

new bool:gShopVipmenu = true
new bool:gAwpBlock;
new bool:gVipmenuActive[33];
new grenades, pistols, armor
new vipinfo, vip_motd
new bulletdmg_vip, g_hudmsg1, g_hudmsg2
new g_pHp[ 3 ], chat_message

new awp_vip, cvar_player, awp_block, awp_limit

enum
{ 
    SCOREATTRIB_ARG_PLAYERID = 1, 
    SCOREATTRIB_ARG_FLAGS 
};

enum ( <<= 1 )
{ 
    SCOREATTRIB_FLAG_NONE = 0, 
    SCOREATTRIB_FLAG_DEAD = 1, 
    SCOREATTRIB_FLAG_BOMB, 
    SCOREATTRIB_FLAG_VIP 
}; 

new vip_score, vip_check

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	register_dictionary("simple_vip.txt")
	
	register_event("TextMsg", "round_restart", "a", "2=#Game_will_restart_in")
	RegisterHam( Ham_Spawn, "player", "FnHamSpawn", 1 )
	
	new configsdir[64], file[132]
	get_configsdir(configsdir, 63)
	
	format(file, 131, "%s/blockedmaps.ini", configsdir)	
	load_maps(file)
	
	register_cvar("vipmenu_respawn","2")
	
	pistols = register_cvar("vipmenu_pistols","1")
	grenades = register_cvar("vipmenu_grenades","1")
	armor = register_cvar("vipmenu_armor","1")
	
	register_clcmd("say /noriuvip", "motd")
	vipinfo = register_cvar("vipinfo_website", "http://amxmodx.lt/viewtopic.php?f=12&t=5707")
	vip_motd = register_cvar("vipmenu_motd","1")
	
	register_event("Damage", "on_damage", "b", "2!0", "3=0", "4!0")
	bulletdmg_vip = register_cvar("bulletdmg_vip","1")
	g_hudmsg1 = CreateHudSyncObj()
	g_hudmsg2 = CreateHudSyncObj()
	
	register_event( "DeathMsg", "Event_DeathMsg", "a" )
	g_pHp[ 0 ] = register_cvar( "amx_vip_hpadd", "10" )
	g_pHp[ 1 ] = register_cvar( "amx_vip_hsadd", "20" )
	g_pHp[ 2 ] = register_cvar( "amx_vip_hpmax", "100" )
	
	chat_message = register_cvar( "amx_hpbonus_msg", "2" )
	
	register_event("CurWeapon", "event_CurWeapon", "be")
	awp_vip = register_cvar( "amx_vip_awp", "1" )
	awp_limit = register_cvar( "amx_awp_limit", "1" )
	awp_block = register_cvar( "amx_awp_block", "1" )
	cvar_player = register_cvar("na_players_count", "10") // psychical code
	
	vip_score = register_cvar( "amx_vip_tag", "1" )
	register_message( get_user_msgid( "ScoreAttrib" ), "MessageScoreAttrib" );

	vip_check = register_cvar( "amx_vip_check", "1" )
	register_clcmd("say", "handle_say") // OneEyed code
}

public plugin_cfg()
{
	new cfgdir[32];
	get_configsdir(cfgdir, charsmax(cfgdir));
	
	server_cmd("exec %s/simple_vip.cfg", cfgdir);
}

public load_maps(path[])
{
	new szMapname[64], szMap[64]
	new file = fopen(path, "rt")

	if(!file)
	{
		server_print("Nepavyko rasti blockedmaps.ini failo!")
		return PLUGIN_HANDLED
	}

	while(!feof(file))
	{
		fgets(file, szMapname, 63)
		if(equal(szMapname[0], "") || equal(szMapname[0], ";"))
		{
			continue;
		}
		get_mapname(szMap, 63)
		if(equali(szMap, szMapname))
		{
			gShopVipmenu = false;
		}
	}
	fclose(file);
	return PLUGIN_CONTINUE
}

public round_restart()
{
	CurrentRespawn[0] = 1;
}

public FnHamSpawn(id)
{
	CurrentRespawn[id]++;
	
	if(is_user_alive(id))
	{
		if(gShopVipmenu)
		{
			if(CurrentRespawn[id] >= get_cvar_num( "vipmenu_respawn" ) )
			{
				if(get_user_flags(id) & VIP )
				{
					gVipmenuActive[id] = true
					set_task(REMOVE_MENU, "close_menu", id )
					vipmenu(id);
				}
			}
			
			if(get_pcvar_num(pistols) == 1 && CurrentRespawn[id] <= get_cvar_num( "vipmenu_respawn" ))
			{
				if(get_user_flags(id) & VIP )
				{
					gVipmenuActive[id] = true
					set_task(REMOVE_MENU, "close_menu", id )
					vipmenu2(id)
				}
			}
		}
	}
}

public close_menu(id)
{
	if(gVipmenuActive[id])
	{
		client_cmd(id, "slot10" )
		gVipmenuActive[id] = false
		ChatColor(id, "%L", LANG_PLAYER, "CLOSED" )
	}
}

public vipmenu(id) 
{
	new menu = menu_create("\w[\y VIP MENU \w]", "menu_handler");
	menu_additem(menu, "\wM4A1 + Deagle", "1", 0);
	menu_additem(menu, "\wAK47 + Deagle", "2", 0);
	menu_additem(menu, "\wFAMAS + Deagle", "3", 0);
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
	menu_display(id, menu, 0); 
}

public vipmenu2(id) 
{
	new menu = menu_create("\w[\y VIP MENU \w]", "menu_handler");
	menu_additem(menu, "\wGlock", "4", 0);
	menu_additem(menu, "\wUsp", "5", 0);
	menu_additem(menu, "\wDeagle", "6", 0);
	menu_setprop(menu, MPROP_EXIT, MEXIT_ALL)
	menu_display(id, menu, 0); 
}

public menu_handler(id, menu, item)
{
	if( item == MENU_EXIT )
	{
		give_items(id);
		gVipmenuActive[id] = false;
		menu_destroy(menu);
		return PLUGIN_HANDLED;
	}
	
	new data[6], iName[64];
	new acess, callback;
   
	menu_item_getinfo(menu, item, acess, data,6, iName, 63, callback);
	new key = str_to_num(data);
	
	switch(key)
	{	
		case 1: { give_weapons(id, CSW_M4A1, 90, CSW_DEAGLE, 35); }
		case 2: { give_weapons(id, CSW_AK47, 90, CSW_DEAGLE, 35); }
		case 3: { give_weapons(id, CSW_FAMAS, 90, CSW_DEAGLE, 35); }
		case 4: { give_weapon(id, CSW_GLOCK18, 120); }
		case 5: { give_weapon(id, CSW_USP, 100); }		
		case 6: { give_weapon(id, CSW_DEAGLE, 35); }
	}
	
	gVipmenuActive[id] = false;
	menu_destroy(menu);
	return PLUGIN_HANDLED;
}

public give_weapons(id, prim, ammo1, sec, ammo2)
{
	HasC4[id] = (user_has_weapon(id, CSW_C4) && get_user_team(id) == 1)
	
	new weapon[32]
	strip_user_weapons (id)
	get_weaponname(prim, weapon, 31)
	give_item(id,weapon)
	cs_set_user_bpammo(id, prim, ammo1)
 
	get_weaponname(sec, weapon, 31)
	give_item(id,weapon)
	cs_set_user_bpammo(id, sec, ammo2)
 
	give_item(id,"weapon_knife")
    
	if(HasC4[id])
	{
		give_item(id, "weapon_c4")
		cs_set_user_plant( id )
	}
	
	give_items(id)
}

public give_weapon(id, sec, ammo)
{
	HasC4[id] = (user_has_weapon(id, CSW_C4) && get_user_team(id) == 1)

	new weapon[32]
	strip_user_weapons (id)
	get_weaponname(sec, weapon, 31)
	give_item(id,weapon)
	cs_set_user_bpammo(id, sec, ammo)
 
	give_item(id,"weapon_knife")
    
	if (HasC4[id])
	{
		give_item(id, "weapon_c4")
		cs_set_user_plant( id )
	}
	
	give_items(id)
}

give_items(id)
{
	if(is_user_alive(id))
	{
		if(get_pcvar_num(grenades) == 1)
		{
			give_item(id, "weapon_hegrenade");
			give_item(id, "weapon_smokegrenade");
			give_item(id, "weapon_flashbang");
			cs_set_user_bpammo(id, CSW_FLASHBANG, 2);
		}
		
		if(get_pcvar_num(armor) == 1)
		{
			give_item(id, "item_assaultsuit");
			if(get_user_team(id) == 2)
				give_item(id, "item_thighpack");
		}
	}
}

public motd(id)
{
	if(get_pcvar_num(vip_motd) == 1)
		Link( id, "%s" )
}

stock Link( id, url[] )
{
	static html[ 128 ]
	new site[64]
	get_pcvar_string(vipinfo, site, charsmax(site))
	
	format( html, 127, "<html><head><META HTTP-EQUIV=^"Refresh^" CONTENT=^"0; URL=%s^"></head><body bgcolor=^"black^" scroll=^"yes^"><a href=^"%s^">VIP privilegijos</a></body></html>", site, url, url, url )

	show_motd( id, html, "Pirkti VIP" )
}

public on_damage(id) 
{ 
	static attacker; attacker = get_user_attacker(id)
	static damage; damage = read_data(2)
	
	if(get_pcvar_num(bulletdmg_vip) == 1)
	{    
		if( get_user_flags(id) & VIP ) 
		{
			set_hudmessage(255, 0, 0, 0.45, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
			ShowSyncHudMsg(id, g_hudmsg2, "%i^n", damage)
		}
		
		if(is_user_connected(attacker)) 
		{
			if( get_user_flags(attacker) & VIP )
			{ 
				set_hudmessage(0, 100, 200, -1.0, 0.55, 2, 0.1, 4.0, 0.02, 0.02, -1) 
				ShowSyncHudMsg(attacker, g_hudmsg1, "%i^n", damage) 
			}
		}
	}
	
	else if(get_pcvar_num(bulletdmg_vip) == 2)
	{
		set_hudmessage(255, 0, 0, 0.45, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
		ShowSyncHudMsg(id, g_hudmsg2, "%i^n", damage)
		if(is_user_connected(attacker)) 
		{
			set_hudmessage(0, 100, 200, -1.0, 0.55, 2, 0.1, 4.0, 0.02, 0.02, -1) 
			ShowSyncHudMsg(attacker, g_hudmsg1, "%i^n", damage)
		}
	}
	
	else if(get_pcvar_num(bulletdmg_vip) == 3)
	{
		set_hudmessage(255, 0, 0, 0.45, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
		ShowSyncHudMsg(id, g_hudmsg2, "%i^n", damage)
		if(is_user_connected(attacker)) 
		{
			if(fm_is_ent_visible(attacker,id))
			{
				if( get_user_flags(attacker) & VIP )
				{
					set_hudmessage(0, 100, 200, -1.0, 0.55, 2, 0.1, 4.0, 0.02, 0.02, -1) 
					ShowSyncHudMsg(attacker, g_hudmsg1, "%i^n", damage)
				}
			}
		}
	}
	
	else if(get_pcvar_num(bulletdmg_vip) == 4)
	{
		set_hudmessage(255, 0, 0, 0.45, 0.50, 2, 0.1, 4.0, 0.1, 0.1, -1) 
		ShowSyncHudMsg(id, g_hudmsg2, "%i^n", damage)
		if(is_user_connected(attacker)) 
		{
			if(fm_is_ent_visible(attacker,id))
			{
				set_hudmessage(0, 100, 200, -1.0, 0.55, 2, 0.1, 4.0, 0.02, 0.02, -1) 
				ShowSyncHudMsg(attacker, g_hudmsg1, "%i^n", damage)
			}
		}
	}
}

public Event_DeathMsg( )
{
	new iKiller = read_data( 1 )
	new iVictim = read_data( 2 )
	new HeadShot = read_data( 3 )
	
	if( get_user_team( iKiller ) == get_user_team( iVictim ) )
		return
	
	if( iKiller && iVictim != iKiller && get_user_flags(iKiller) & VIP )
	{
		static maxhp, hp
		maxhp = get_pcvar_num( g_pHp[ 2 ] )
		hp = get_user_health( iKiller )
		
		if( hp != maxhp )
		{
			new BonusHp;
			if( HeadShot ) BonusHp = get_pcvar_num( g_pHp[ 1 ] )
			else BonusHp = get_pcvar_num( g_pHp[ 0 ] )
			
			if( hp + BonusHp > maxhp )
			{
				set_user_health( iKiller, maxhp )
				
				if(get_pcvar_num(chat_message) == 1)
					ChatColor(iKiller, "%L", LANG_PLAYER, "HP_BONUS", maxhp - hp )
					
				else if(get_pcvar_num(chat_message) == 2)
				{
					set_hudmessage(0, 255, 0, -1.0, 0.15, 0, 1.0, 1.0, 0.1, 0.1, -1)
					show_hudmessage(iKiller, "%L", LANG_PLAYER, "HP_BONUS", maxhp - hp )
				}	
			} 
			else
			{
				set_user_health( iKiller, hp + BonusHp )
				
				if(get_pcvar_num(chat_message) == 1)
					ChatColor(iKiller, "%L", LANG_PLAYER, "HP_BONUS", BonusHp )
					
				else if(get_pcvar_num(chat_message) == 2)
				{
					set_hudmessage(0, 255, 0, -1.0, 0.15, 0, 1.0, 1.0, 0.1, 0.1, -1)
					show_hudmessage(iKiller, "%L", LANG_PLAYER, "HP_BONUS", BonusHp )
				}
			}
		}
	}	
}

public event_CurWeapon(id)
{
	new szMapname[64]
	get_mapname(szMapname, 63)
	
	if( containi(szMapname, "cs_max") != -1 || containi(szMapname, "2x2") != -1 || containi(szMapname, "fy_") != -1 || containi(szMapname, "aim_") != -1 || containi(szMapname, "mini") != -1)
		gAwpBlock = true
		
	if(containi(szMapname, "awp"))
	{
		switch(read_data(2))
		{
			case CSW_AWP, CSW_SG550, CSW_G3SG1:
			{
				if(get_pcvar_num(awp_block) == 1 && gAwpBlock)
				{
					client_cmd(id, "drop")
					ChatColor(id, "%L", LANG_PLAYER, "AWP_BLOCK" )
				}
				
				if(get_pcvar_num(awp_limit) == 1 && get_playersnum() < get_pcvar_num(cvar_player)) // psychical code
				{
					client_cmd(id, "drop")
					ChatColor(id, "%L", LANG_PLAYER, "AWP_LIMIT", get_pcvar_num(cvar_player) )
				}
				
				if(get_pcvar_num(awp_vip) == 1 && (!(get_user_flags(id) & VIP)))
				{
					client_cmd(id, "drop")
					ChatColor(id, "%L", LANG_PLAYER, "AWP_DROP" )
				}
			}
		}
	}
}

public MessageScoreAttrib( iMsgId, iDest, iReceiver )
{ 
	if( get_pcvar_num( vip_score ) == 1)
	{ 
		new iPlayer = get_msg_arg_int( SCOREATTRIB_ARG_PLAYERID ); 
	
		if( access( iPlayer, VIP ) )
		{ 
			set_msg_arg_int( SCOREATTRIB_ARG_FLAGS, ARG_BYTE, SCOREATTRIB_FLAG_VIP ); 
		} 
	}
}

public handle_say(id)
{
	new said[192]
	read_args(said,192)

	if(get_pcvar_num(vip_check) == 1)
	{
		if(containi(said, "/vip") != -1 )
			show_vip(id)
	}

	return PLUGIN_CONTINUE
}

public show_vip(user) 
{
	new adminnames[32][33]
	new message[256]
	new id, count, x, len
	
	new players[32], playersnum
	get_players(players, playersnum, "ch")
	for(--playersnum; playersnum >= 0; playersnum--)
	{
		id = players[playersnum]
		if(get_user_flags(id) & VIP)
		{
			get_user_name(id, adminnames[count++], charsmax(adminnames[]))
		}
	}

	len = formatex(message, charsmax(message), "^x03Prisijunge VIP:^x04 ", user)
	if(count > 0) 
	{
		for(x = 0 ; x < count ; x++) 
		{
			len += formatex(message[len], charsmax(message)-len, "^1%s%s", adminnames[x], x < (count-1) ? ", ":".")
			if(len > 96) 
			{
				print_message(user, message)
				//len = copy(message, charsmax(message))
				len = format(message, 255, "^x04 ")
			}
		}
		print_message(user, message)
	}
	else
	{
		len += copy(message[len], charsmax(message)-len, "^x01Nera prisijungusiu^x04 VIP")
		print_message(user, message)
	}
}

print_message(id, const msg[])
{
	message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), {0,0,0}, id)
	write_byte(id)
	write_string(msg)
	message_end()
}

stock ChatColor(const id, const input[], any:...)
{
    new count = 1, players[32]
    static msg[192]
    vformat(msg, 191, input, 3)
   
    replace_all(msg, 191, "!g", "^4") // Green Color
    replace_all(msg, 191, "!y", "^1") // Default Color
    replace_all(msg, 191, "!t", "^3") // Team Color
   
    if (id) players[0] = id; else get_players(players, count, "ch")
    {
        for (new i = 0; i < count; i++)
        {
            if (is_user_connected(players[i]))
            {
                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i])
                write_byte(players[i]);
                write_string(msg);
                message_end();
            }
        }
    }
}